Linux-Based Community / Regional
1752778 Members
6306 Online
108789 Solutions
New Discussion юеВ

Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

 
SOLVED
Go to solution
Bruce Edge
Occasional Contributor

Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Hi,
I've just started using this latest PSP with Ubuntu 10.04 (64 bit) and found a couple of problems.

1) Uses rpm -q instead of dpkg -l:

0 #> /usr/sbin/cpqacuxe
/opt/compaq/cpqacuxe/bld//updsmh.sh: 8: rpm: not found
[: 35: 127: unexpected operator

The problem is in this file:

/opt/compaq/cpqacuxe/bld/updsmh.sh

Here's the fix
--- /opt/compaq/cpqacuxe/bld/updsmh.sh.orig 2010-10-08 03:35:56.002856580 -0700
+++ /opt/compaq/cpqacuxe/bld/updsmh.sh 2010-10-08 04:15:29.491411215 -0700
@@ -5,8 +5,8 @@

#
# see if hpsmh is installed and running
-HPSMH_INSTALL=`rpm -q hpsmh`
-if [ $? == 0 ] && [ -f "/opt/hp/hpsmh/logs/httpd.pid" ]
+HPSMH_INSTALL=`dpkg -l hpsmh 2>/dev/null`
+if [ $? -eq 0 ] && [ -f "/opt/hp/hpsmh/logs/httpd.pid" ]
then
# Permissions
chown -R hpsmh:root $INSTALL_ROOT

2) hpsmh includes obsolete libraries that conflice with those on the system.

This renders the hpsmh incompatible with the Ubuntu 10.04 operating system. Anyone that regularly updates their servers will end up with a broken system that they can no longer login to.

After running a normal upgrade on fri, I was unable to login to the box. I found out that there's an incompatible openssl lib that is part of the hpsmh package:
/opt/hp/hpsmh/lib/libssl.so.0.9.8

This package adds this file: /etc/ld.so.conf.d/hpsmh.conf

That contains:
/opt/hp/hpsmh/lib

This tells the OS to use the above path for the default library search path. By doing so, it breaks sshd, the ssh server because it's now looking at an incompatible libssl version.

It should be using this version here:
/usr/lib/libssl.so.0.9.8

But the added file in /etc/ld.so.conf tells all apps to search the /opt dir as well, and if a file of the same name is found there, it'll use that one.

And these files are not the same:

%> diff /usr/lib/libssl.so.0.9.8 /opt/hp/hpsmh/lib/libssl.so.0.9.8

Binary files /usr/lib/libssl.so.0.9.8 and /opt/hp/hpsmh/lib/libssl.so.0.9.8 differ

So, all Ubuntu applications that are linked against the OS provided version are now loading the HP provided one, which is causing them to segfault:

syslog.1:Oct 24 21:51:27 opal kernel: [ 52.311241] automount[1651]: segfault at 61b76e08 ip 00007fcc60088f20 sp 00007fff65ab3890 error 4 in libxml2.so.2.7.2[7fcc60028000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.318301] automount[1659]: segfault at 20a74e08 ip 00007eff1e227f20 sp 00007fff51e88aa0 error 4 in libxml2.so.2.7.2[7eff1e1c7000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.325421] automount[1667]: segfault at ffffffffa101fe08 ip 00007f939f6d0f20 sp 00007fff58d877d0 error 4 in libxml2.so.2.7.2[7f939f670000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.332824] automount[1675]: segfault at 58714e08 ip 00007f3256b02f20 sp 00007fff26f25880 error 4 in libxml2.so.2.7.2[7f3256aa2000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.339497] automount[1683]: segfault at 77e2ce08 ip 00007fe176e4ff20 sp 00007fff3f4a3bd0 error 4 in libxml2.so.2.7.2[7fe176def000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.346590] automount[1691]: segfault at ffffffffaa4cee08 ip 00007fd5a87f6f20 sp 00007fffaf9ba250 error 4 in libxml2.so.2.7.2[7fd5a8796000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.353873] automount[1699]: segfault at ffffffffe019fe08 ip 00007ff5ddb6ef20 sp 00007fffba314e60 error 4 in libxml2.so.2.7.2[7ff5ddb0e000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.360758] automount[1707]: segfault at ffffffffc0fb0e08 ip 00007f41bedbcf20 sp 00007fffe2be6e90 error 4 in libxml2.so.2.7.2[7f41bed5c000+153000]
syslog.1:Oct 24 21:51:27 opal kernel: [ 52.368190] automount[1715]: segfault at 26396e08 ip 00007f1424ce9f20 sp 00007fff005f6d10 error 4 in libxml2.so.2.7.2[7f1424c89000+153000]
syslog.1:Oct 24 21:59:05 opal kernel: [ 510.343459] sshd[11209]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 21:59:08 opal kernel: [ 512.879868] sshd[11210]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 21:59:18 opal kernel: [ 522.977017] sshd[11729]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 21:59:26 opal kernel: [ 530.773227] sshd[11730]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 22:00:52 opal kernel: [ 617.104573] sshd[13327]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 22:01:06 opal kernel: [ 630.794338] sshd[13349]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 22:01:13 opal kernel: [ 638.048537] sshd[13357]: segfault at 7fffa7796000 ip 00007f99d2be28d4 sp 00007fffa7794460 error 6 in sshd[7f99d2b93000+6c000]
syslog.1:Oct 24 22:09:03 opal kernel: [ 1107.035771] sshd[22227]: segfault at 7fff50064000 ip 00007f51059fd8d4 sp 00007fff50061e90 error 6 in sshd[7f51059ae000+6c000]

The problem is that the hpsmh package is including it's own copy of libssl.so.0.9.8. Instead, it should be linking with the one provided by the operating system.

Note that the same problem applies to ALL of the included libraries packaged as part of hpsmh:

ls -l /opt/hp/hpsmh/lib
-rw-r--r-- 1 root root 860 2009-08-08 18:11 libapr-1.la
lrwxrwxrwx 1 root root 18 2010-10-08 03:31 libapr-1.so -> libapr-1.so.0.2.11
lrwxrwxrwx 1 root root 18 2010-10-08 03:31 libapr-1.so.0 -> libapr-1.so.0.2.11
-rw-r--r-- 1 root root 202104 2009-08-08 18:17 libapr-1.so.0.2.11
-rw-r--r-- 1 root root 872 2009-08-08 18:11 libapriconv-1.la
lrwxrwxrwx 1 root root 23 2010-10-08 03:31 libapriconv-1.so -> libapriconv-1.so.0.2.11
lrwxrwxrwx 1 root root 23 2010-10-08 03:31 libapriconv-1.so.0 -> libapriconv-1.so.0.2.11
-rw-r--r-- 1 root root 50224 2009-08-08 18:17 libapriconv-1.so.0.2.11
-rw-r--r-- 1 root root 939 2009-08-08 18:12 libaprutil-1.la
lrwxrwxrwx 1 root root 22 2010-10-08 03:31 libaprutil-1.so -> libaprutil-1.so.0.2.11
lrwxrwxrwx 1 root root 22 2010-10-08 03:31 libaprutil-1.so.0 -> libaprutil-1.so.0.2.11
-rw-r--r-- 1 root root 128672 2009-08-08 18:17 libaprutil-1.so.0.2.11
lrwxrwxrwx 1 root root 18 2010-10-08 03:31 libcrypto.so -> libcrypto.so.0.9.8
-rw-r--r-- 1 root root 1570904 2009-08-08 18:17 libcrypto.so.0.9.8
lrwxrwxrwx 1 root root 15 2010-10-08 03:31 libssl.so -> libssl.so.0.9.8
-rw-r--r-- 1 root root 308464 2009-08-08 18:17 libssl.so.0.9.8
-rw-r--r-- 1 root root 808 2009-08-08 18:15 libxml2.la
lrwxrwxrwx 1 root root 16 2010-10-08 03:31 libxml2.so -> libxml2.so.2.7.2
lrwxrwxrwx 1 root root 16 2010-10-08 03:31 libxml2.so.2 -> libxml2.so.2.7.2
-rw-r--r-- 1 root root 1422896 2009-08-08 18:17 libxml2.so.2.7.2

I'd like to work with HP in getting these issues resolved, so please let me know what other information you need.

Thanks

-Bruce
10 REPLIES 10
Bryan Gartner
Valued Contributor
Solution

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Thanks for the detailed report and suggested fixes. As revisions are currently in progress, we'll try to address each of these issues and get a new version published.
Andreas Ntaflos
New Member

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Thank you for reporting those bugs Bruce, I noticed them as well (luckily not on production machines).

There is another detail that needs to be addressed. In Ubuntu (and I believe in recent Debian versions) "/etc/ld.so.conf" is a flat file that contains just one line:

include /etc/ld.so.conf.d/*.conf

All configuration goes into "/etc/ld.so.conf.d" in the form of .conf files.

The hpsmh package doesn't behave correctly: instead of putting its configuration in "/etc/ld.so.conf.d", it deletes "/etc/ld.so.conf", creates a directory with the same name and puts its configuration in there instead.

This completely breaks the update process when the system (apt-get, aptitude, ...) tries to update packages such as libc6. The fix is to conform to the conventions described above and not delete the config file "/etc/ld.so.conf".

I'd provide a patch for the postinst script of the package but I did not yet have time to test it thoroughly enough.

Hopefully this gets fixed in the next version as well.
Bruce Edge
Occasional Contributor

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

I'm confirming Andreas Ntaflos's post that it does indeed break the /etc/ld.so.conf file.

I noticed this symptom as well and wasn't sure where this happened as I had a lot of activity on this server.

Thanks for shedding light on this.

-Bruce
Thomas St├╝tz
New Member

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

I noticed the same problem's with Ubuntu 64bit.
Thanks for the info!
blabla1
New Member

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Hi,

same problem here with the PSP.

Any news when HP will provide a fixed PSP for Debian/Ubuntu?

thanks
Mike Watt
Occasional Visitor

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

I've just fallen into this trap running Debian 5.0.4. However, even after removing the hpsmh.conf from /etc/ld.so.conf.d I'm still not able to start the SSHd, even a reboot doesn't fix it.

Is there any way to fix this problem?
Mike Watt
Occasional Visitor

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

OK, I bodged it and now it's working.

I renamed /opt/hp/hpsmh/lib to lib.hp and made a symlink to /usr/lib. Then inside /usr/lib I ran:

cp -i -s /opt/hp/hpsmh/lib.hp/* ./

This made symlinks to all the files that the HP software would be looking for and allowed me to deny overwriting existing files.

Once I'd done that everything worked, but it feels like a massive kludge. Happy to take suggestions of more elegant ways to do it!
Andreas Ntaflos
New Member

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Mike, did you run "ldconfig" after you removed the hpshm library configuration from /etc/ld.so.conf.d? I don't think the workaround you applied is necessary.
Mike Watt
Occasional Visitor

Re: Ubuntu 10.04 Software-8.50-8-8.iso bug reports & patch

Ah, no, I wasn't aware of that command!

That should solve the first part, but still requires symlinking the missing HP libraries into /usr/lib.

That's good enough for me, for now!